# -*- coding: utf-8 -*-
import uuid
from openerp.addons.base.maintenance.migrations import util

# TODO review, factorize?, avoid hardcoding when posssible

def migrate(cr, version):

    if not util.module_installed(cr, 'sale_contract'):
        raise util.MigrationError('Please run the `init` script before updatingt this module')

    cr.execute("UPDATE ir_ui_view SET active='f' WHERE id=2318;")

    # copy all credit card data to table payment_method and set acquirer_id to ogone (2)
    cr.execute("""
        INSERT INTO payment_method
        (name, acquirer_ref, acquirer_id, partner_id, create_date, create_uid, write_uid, write_date, active)
        SELECT number || ' - ' || holder_name, provider_ref, 2, partner_id, create_date, create_uid, write_uid, write_date, 't'
        FROM openerp_payment_creditcard;
        """)

    # set payment_method_id on contracts when partner_id has a default creditcard
    cr.execute("""
        UPDATE account_analytic_account acc
        SET payment_method_id = sq.pm_id
        FROM (
            SELECT p.id as partner_id,p.default_credit_card_id,cc.id,pm.id as pm_id
            FROM res_partner p,openerp_payment_creditcard cc,payment_method pm
            WHERE p.default_credit_card_id = cc.id AND cc.provider_ref=pm.acquirer_ref) as sq
        WHERE sq.partner_id = acc.partner_id;
        """)

    # remove openerp_payment : not at this time, let's keep both payment systems just in case
    # before uninstalling module: remove group
    # cr.execute("""
    #     DELETE FROM res_groups_users_rel WHERE gid=103;
    #     """)
    # bad idea?
    # util.remove_module(cr, 'openerp_payment')

    # move openerp specific close reasons to sale contract
    cr.execute("""
        DELETE FROM account_analytic_close_reason;
    """)
    cr.execute("""
        INSERT INTO account_analytic_close_reason (id, create_uid, create_date, write_date, write_uid, name)
        SELECT * FROM openerp_enterprise_close_reason;
    """)
    cr.execute("""
        SELECT setval('account_analytic_close_reason_id_seq', (SELECT MAX(id) from account_analytic_close_reason));
        """)

    cr.execute("""
        UPDATE account_analytic_account
        SET close_reason_id = enterprise_close_reason_id
        WHERE enterprise_close_reason_id IS NOT NULL;
        """)

    # move all contract descriptions to chatter (they will be visible to the public from now on and most of them are fugly notes)
    cr.execute("""
        INSERT INTO mail_message (body,author_id,model,res_id,type)
        SELECT 'Contract description prior to new contract management system:<br/>' || regexp_replace(description, '\n', '<br/>', 'g'),
               1,'account.analytic.account',id,'message'
        FROM account_analytic_account WHERE description IS NOT NULL;
        """)
    cr.execute("""
        UPDATE account_analytic_account SET description=NULL WHERE description IS NOT NULL;
        """)

    # close all current templates
    cr.execute("""
    UPDATE account_analytic_account
    SET state='close'
    WHERE type='template';
    """)

    # new intermediary analytic account (completed by xml)
    cr.execute("""
        INSERT INTO account_analytic_account (name,type,state,parent_id,contract_type,uuid)
        VALUES ('Odoo Online','normal','open',4056,'regular',%s)
        RETURNING id;
        """, [str(uuid.uuid4())])
    id_aa_online, = cr.fetchone()
    cr.execute("""
        INSERT INTO ir_model_data (name,module,model,res_id)
        VALUES ('odoo_online_analytic', 'openerp_enterprise','account.analytic.account',%s)
        """, [id_aa_online])

    # create new templates
    id_aa_partnership = 4060
    id_aa_enterprise = 4056
    cr.execute("""
    INSERT INTO account_analytic_account (name,type,state,recurring_rule_type,recurring_next_date,recurring_interval,recurring_invoices,payment_mandatory,user_selectable,contract_type,company_id,parent_id,uuid)
    VALUES ('Odoo Enterprise','template','open','yearly','2000-01-01','1','t','t','t','subscription','1',%s,%s),
           ('Odoo Online Monthly','template','open','monthly','2000-01-01','1','t','t','t','subscription','1',%s,%s),
           ('Odoo Online Yearly','template','open','yearly','2000-01-01','1','t','t','t','subscription','1',%s,%s),
           ('Odoo Partnership','template','open','yearly','2000-01-01','1','t','t','t','subscription','1',%s,%s)
    RETURNING name, id;
    """, [id_aa_enterprise, str(uuid.uuid4()),
          id_aa_online, str(uuid.uuid4()),
          id_aa_online, str(uuid.uuid4()),
          id_aa_partnership, str(uuid.uuid4()),
          ])

    aas = dict(cr.fetchall())
    id_enterprise = aas['Odoo Enterprise']
    id_online_monthly = aas['Odoo Online Monthly']
    id_online_yearly = aas['Odoo Online Yearly']
    id_partnership = aas['Odoo Partnership']

    cr.execute("""
        INSERT INTO ir_model_data (name,module,model,res_id)
        VALUES ('template_online_monthly', 'openerp_enterprise','account.analytic.account',%s)
        """, [id_online_monthly])

    # convert all enterprise and partnership contracts and template to subscription
    cr.execute("""
        UPDATE account_analytic_account
        SET contract_type = 'subscription'
        WHERE parent_id IN %s AND state in ('open','pending');
        """, [(id_aa_enterprise, id_aa_partnership)])

    # remove timesheets from subscription
    cr.execute("""
    UPDATE account_analytic_account
    SET use_timesheets='f'
    WHERE contract_type='subscription';
    """)

    # setting the right templates: to odoo enterprise: yearly, not hosted by odoo, parent_id = 4056, state in (open,pending)
    cr.execute("""
    UPDATE account_analytic_account
    SET template_id=%s
    WHERE type='contract'
        AND contract_type='subscription'
        AND parent_id = %s
        AND recurring_rule_type = 'yearly'
        AND state in ('open','pending')
        AND enterprise_saas='f';
    """, [id_enterprise, id_aa_enterprise])
    cr.execute("""
        UPDATE account_analytic_account
        SET date=NULL
        WHERE template_id=%s AND state in ('open','pending') and date=recurring_next_date;
        """, [id_enterprise])

    # no questions asked for partnerships, everyone gets migrated to the new template
    cr.execute("""
    UPDATE account_analytic_account
    SET template_id=%s
    WHERE type='contract'
        AND contract_type='subscription'
        AND parent_id = %s
        AND state in ('open','pending');
    """, [id_partnership, id_aa_partnership])
    cr.execute("""
    UPDATE account_analytic_account
    SET date=NULL
    WHERE template_id=%s AND state in ('open','pending') and date=recurring_next_date;
    """, [id_partnership])

    # id_saas_monthly = 17772
    # id_saas_yearly = 17773
    # to odoo online monthly: monthly, hosted by odoo, parent_id = 4056 and state in open,pending, paid
    cr.execute("""
    UPDATE account_analytic_account
    SET template_id=%s
    WHERE type='contract'
        AND contract_type='subscription'
        AND parent_id = %s
        AND enterprise_saas = 't'
        AND recurring_rule_type = 'monthly'
        AND state in ('open','pending')
        AND recurring_total > 0;
    """, [id_online_monthly, id_aa_enterprise])
    cr.execute("""
        UPDATE account_analytic_account
        SET date=NULL
        WHERE template_id=%s AND state in ('open','pending') and date=recurring_next_date;
        """, [id_online_monthly])

    # to odoo online yearly: yearly, hosted by odoo, parent_id = 4056 and state in open,pending, paid
    cr.execute("""
    UPDATE account_analytic_account
    SET template_id=%s
    WHERE type='contract'
        AND contract_type='subscription'
        AND parent_id = %s
        AND enterprise_saas = 't'
        AND recurring_rule_type = 'yearly'
        AND state in ('open','pending')
        AND recurring_total > 0;
    """, [id_online_yearly, id_aa_enterprise])
    cr.execute("""
        UPDATE account_analytic_account
        SET date=NULL
        WHERE template_id=%s AND state in ('open','pending') and date=recurring_next_date
        """, [id_online_yearly])

    # monthly: for all analytic invoice lines with, we set the sold quantity and the actual quantity to the current quantity
    # the ping will take care of the actual quantity (we lose some history)
    cr.execute("""
        UPDATE account_analytic_invoice_line il
        SET sold_quantity = quantity, actual_quantity=quantity
        FROM account_analytic_account as a
        WHERE il.analytic_account_id = a.id and a.template_id = %s
    """, [id_online_monthly])

    # yearly: for all analytic invoice lines, we set the sold quantity to the enterprise_max_users quantity (only for users), and the actual quantity to the current quantity
    cr.execute("""
        SELECT p.id,p.name_template,t.description,t.uom_id,t.list_price
        FROM product_template AS t,product_product AS p
        WHERE p.name_template= 'Odoo Enterprise User' AND p.product_tmpl_id=t.id
        """)
    enterprise_user = cr.dictfetchall()[0]
    cr.execute("""
        UPDATE account_analytic_invoice_line il
        SET sold_quantity = case when il.product_id = %s
                                 then enterprise_max_users
                                 else quantity
                                 end,
            actual_quantity = quantity
        FROM account_analytic_account AS a
        WHERE il.analytic_account_id = a.id AND a.template_id = %s
    """, [enterprise_user['id'], id_online_yearly])



    # for all saas contracts, we replace the Odoo Enterprise User by a Odoo Online User (we don't like barbarians because if
    # we trigger the onchange all the prices will be adapted and we don't want that)
    cr.execute("""
        SELECT p.id,p.name_template,t.uom_id,t.list_price
        FROM product_template AS t,product_product AS p
        WHERE p.name_template= 'Odoo Online User' AND p.product_tmpl_id=t.id;
        """)
    online_user = cr.dictfetchall()[0]
    cr.execute("""
        UPDATE account_analytic_invoice_line il
        SET product_id = %s
        FROM account_analytic_account a
        WHERE il.analytic_account_id = a.id and a.template_id in %s AND product_id = %s
        """, [online_user['id'], (id_online_monthly, id_online_yearly), enterprise_user['id']])


    def add_option(aa_id, product_id, name, uom_id, list_price, quantity=1,
                   actual_quantity=0, portal_access='invisible'):
        cr.execute("""INSERT INTO account_analytic_invoice_line_option
                             (product_id,name,uom_id,quantity,actual_quantity,price_unit,portal_access,analytic_account_id)
                      VALUES (%s, %s, %s, %s, %s, %s, %s, %s)
                   """, [product_id, name, uom_id, quantity, actual_quantity, list_price,
                         portal_access, aa_id])

    # we need to create an xmlid for the odoo online user which is already in the db
    cr.execute("""
        INSERT INTO ir_model_data (name,module,model,res_id)
        VALUES ('product_user_online_month', 'openerp_enterprise','product.product',%s)
        """, [online_user['id']])

    # options for odoo online/enterprise
    cr.execute("""
    SELECT p.id as product_id, t.description as name, t.list_price
      FROM product_product p JOIN product_template t ON (t.id = p.product_tmpl_id)
     WHERE p.active = true
       AND t.categ_id = 42
    """)
    for app in cr.dictfetchall():
        add_option(id_online_monthly, uom_id=41, **app)
        add_option(id_online_yearly, uom_id=29, **app)

    cr.execute("""
    SELECT p.id as product_id, p.name_template as name, t.uom_id, t.list_price
      FROM product_product p JOIN product_template t ON (t.id = p.product_tmpl_id)
     WHERE p.name_template IN ('Extra Company', '[Online] Specific Development')
    """)
    for p in cr.dictfetchall():
        add_option(id_online_monthly, **p)
        add_option(id_online_yearly, **p)
        add_option(id_enterprise, **p)

    cr.execute("""
    SELECT p.id as product_id, p.name_template as name, t.uom_id, t.list_price
      FROM product_product p JOIN product_template t ON (t.id = p.product_tmpl_id)
     WHERE p.name_template IN ('Unlimited technical support', 'Unlimited Technical Training')
    """)
    for p in cr.dictfetchall():
        add_option(id_partnership, portal_access='upgrade', **p)


    def add_line(aa_id, product_id, name, uom_id, list_price, quantity=1, sold_quantity=1):
        cr.execute("""INSERT INTO account_analytic_invoice_line
                             (product_id,name,uom_id,quantity,sold_quantity,price_unit,analytic_account_id)
                      VALUES (%s, %s, %s, %s, %s, %s, %s)
                   """, [product_id, name, uom_id, quantity, sold_quantity, list_price, aa_id])

    online_line = dict(online_user)
    online_line['product_id'] = online_line.pop('id')
    online_line['name'] = online_line.pop('name_template')
    add_line(id_online_monthly, **online_line)
    add_line(id_online_yearly, **online_line)

    add_line(id_enterprise, enterprise_user['id'], enterprise_user['name_template'],
             enterprise_user['uom_id'], enterprise_user['list_price'])

    # lines for partnership !!!!! the product must exist in the db (creation via backend) !!!!!!!!!!!!
    cr.execute("""
    SELECT p.id as product_id, p.name_template as name, t.uom_id, t.list_price
      FROM product_product p JOIN product_template t ON (t.id = p.product_tmpl_id)
     WHERE p.name_template = 'Yearly Partnership Fee'
    """)
    partner_fee = cr.dictfetchall()[0]
    add_line(id_partnership, **partner_fee)

    # as long as we're here, let's add the partnership to everyone since it's mandatory
    cr.execute("""SELECT id
                    FROM account_analytic_account
                   WHERE template_id=%s
                     AND state in ('open','pending')
               """, [id_partnership])
    for aa_id, in cr.fetchall():
        add_line(aa_id, **partner_fee)

if __name__ == '__main__':
    util.main(migrate)
